<p *ngIf="!containsData(); else validData">No journal data to analyse</p>
<ng-template #validData>
  <section class="options">
    <mat-form-field>
      <mat-label>GameMode</mat-label>
      <mat-select [(value)]="filterGameMode">
        <mat-option *ngFor="let gameMode of gameModes" [value]="gameMode.Value">{{gameMode.Name}}</mat-option>
      </mat-select>
    </mat-form-field>
    <mat-form-field>
      <mat-label>Star System</mat-label>
      <mat-select [(value)]="filterStarSystem">
        <mat-option *ngFor="let starSystem of starSystems" [value]="starSystem.Address">{{starSystem.Name}}</mat-option>
      </mat-select>
    </mat-form-field>
    <mat-form-field>
      <mat-label>Body</mat-label>
      <mat-select [(value)]="filterBody">
        <mat-option *ngFor="let body of bodies" [value]="body">{{body.Name}}</mat-option>
      </mat-select>
    </mat-form-field>
    <button mat-stroked-button color="primary" (click)="analyse()">Filter</button>
  </section>

  <div class="card-flex dark">
    <mat-card class="card-stats">
      <mat-card-header>
        <mat-card-title>Stats</mat-card-title>
      </mat-card-header>
      <mat-card-content>
        <ul>
          <li>Analyzed journal entries: {{eventCount}}</li>
          <li *ngIf="prospectedAsteroidCount > 0">Prospected asteroids: {{prospectedAsteroidCount}} (Hit rate {{(prospectedAsteroidCount / launchedProspectors) | percent:'2.1'}})</li>
          <li *ngIf="launchedProspectors > 0">Launched prospector drones: {{launchedProspectors}}</li>
          <li *ngIf="launchedCollections > 0">Launched collection drones: {{launchedCollections}}</li>
          <li>Total launched drones: {{launchedCollections + launchedProspectors}}</li>
        </ul>
      </mat-card-content>
    </mat-card>

    <mat-card class="card-asteroid-material-stats">
      <mat-card-header>
        <mat-card-title>Material stats</mat-card-title>
      </mat-card-header>
      <mat-card-content>
        <app-material-stats [stats]="materialStats"></app-material-stats>
      </mat-card-content>
    </mat-card>

    <mat-card class="card-asteroid-material-percentiles">
      <mat-card-header>
        <mat-card-title>Material percent amount</mat-card-title>
      </mat-card-header>
      <mat-card-content>
        <ngx-charts-bubble-chart
          [results]="asteroidMaterialPercentilesCharData"
          scheme="picnic"
        >
          <ng-template #tooltipTemplate let-model="model">
            <h3>{{model.y}} {{model.x}}%</h3>
            <h2>Amount {{model.r}}</h2>
          </ng-template>
        </ngx-charts-bubble-chart>
      </mat-card-content>
    </mat-card>
  </div>

  <hr>
  <h2>Percentiles</h2>

  <div class="card-flex dark">
    <mat-card class="card-asteroid-material-percent-detail" *ngFor="let item of objectKeys(asteroidMaterialPercentCharData).sort()">
      <mat-card-header>
        <mat-card-title>{{item}}</mat-card-title>
      </mat-card-header>
      <mat-card-content>
        <ngx-charts-bar-vertical
          [results]="asteroidMaterialPercentCharData[item]"
          [yAxis]="true"
          [xAxis]="true"
          [roundEdges]="false"
          scheme="aqua"
          schemeType="linear"
        >
        </ngx-charts-bar-vertical>
      </mat-card-content>
    </mat-card>
  </div>

  <hr>
  <div class="header-cumulative-frequency">
    <h2>%Content Distribution</h2>
  </div>
  <div>
    <mat-form-field appearance="fill">
      <mat-label>Chart type</mat-label>
      <mat-select [(value)]="cumulativeFrequencyChartType">
        <mat-option value="CDFb">CDFb</mat-option>
        <mat-option value="CDF">CDF</mat-option>
      </mat-select>
    </mat-form-field>
  </div>

  <div class="card-flex dark">
    <ng-template ngFor let-item [ngForOf]="objectKeys(asteroidMaterialCumulativeFrequencyChartDataCDFb).sort()">
      <mat-card class="card-cumulative-frequency" *ngIf="cumulativeFrequencyChartType === 'CDFb'">
        <mat-card-header>
          <mat-card-title>CDFb: {{item}}</mat-card-title>
        </mat-card-header>
        <mat-card-content>
          <ngx-charts-line-chart
            [results]="asteroidMaterialCumulativeFrequencyChartDataCDFb[item]"
            [yAxis]="true"
            [showXAxisLabel]="true"
            xAxisLabel="%content"
            [xAxis]="true"
            [showYAxisLabel]="true"
            yAxisLabel="% of asteroids above %content (CDFb)"
            [yAxisTickFormatting]="percentTickFormatting"
            [yScaleMin]="0"
            [yScaleMax]="1"
            [xScaleMin]="0"
            [xScaleMax]="70"
            [legend]="asteroidMaterialCumulativeFrequencyChartDataCDFb[item].length > 1"
            scheme="picnic"
          >
          </ngx-charts-line-chart>
        </mat-card-content>
      </mat-card>
      <mat-card class="card-cumulative-frequency" *ngIf="cumulativeFrequencyChartType === 'CDF'">
        <mat-card-header>
          <mat-card-title>CDF: {{item}}</mat-card-title>
        </mat-card-header>
        <mat-card-content>
          <ngx-charts-line-chart
            [results]="asteroidMaterialCumulativeFrequencyChartDataCDF[item]"
            [yAxis]="true"
            [showXAxisLabel]="true"
            xAxisLabel="%content"
            [xAxis]="true"
            [showYAxisLabel]="true"
            yAxisLabel="% of asteroids below %content (CDF)"
            [yAxisTickFormatting]="percentTickFormatting"
            [yScaleMin]="0"
            [yScaleMax]="1"
            [xScaleMin]="0"
            [xScaleMax]="70"
            [legend]="asteroidMaterialCumulativeFrequencyChartDataCDF[item].length > 1"
            scheme="picnic"
          >
          </ngx-charts-line-chart>
        </mat-card-content>
      </mat-card>
    </ng-template>
  </div>
</ng-template>


